/***************************************************************************
			 mysubs.cpp: common functions
                             -------------------
    begin                : 2005/01/19
    copyright            : (C) 2005 by Meijian An
    email                : meijian@iag.usp.br
 ***************************************************************************/

#include <cstdio>
#include <cmath>
#include <limits>
#include <numeric>
#include "mystds.h"
#include "mysubs.h"

using namespace std;
//transform(v.begin(),v.end(),v.begin(), bind2nd(divides<float>(), 3));


/*transform coordinate from geodesic to geocentric*/
void geodesic2geocentric(double *lat)
{
	*lat = A2D(atan( 0.993277*tan( D2A(*lat) ) ));
}

int GetDisAz(double dEvLat, double dEvLon, double dStLat, double dStLon, float *pAz, float *pBaz, float *pDist, float *pGcArc)
{
	double az, baz, dist, gcarc;
	GetDisAz(dEvLat, dEvLon, dStLat, dStLon, &az, &baz, &dist, &gcarc);
	*pAz = (float)az;
	*pBaz = (float)baz;
	*pDist = (float)dist;
	*pGcArc = (float)gcarc;
	return 1;
}

int GetDisAz(double dEvLat, double dEvLon, double dStLat, double dStLon, double *pAz, double *pBaz, double *pDist, double *pGcArc)
{
	/*Transform from Geodesica system to Geocentric system*/
	//geodesic2geocentric(&dEvLat);
	//geodesic2geocentric(&dStLat);

	/*degree to Arc*/
	dEvLat = D2A( dEvLat );
	dEvLon = D2A( dEvLon );
	dStLat = D2A( dStLat );
	dStLon = D2A( dStLon );

	/*Get the Greate Cycle Arc*/
	*pGcArc = A2D(acos( sin(dEvLat)*sin(dStLat)+cos(dEvLat)*cos(dStLat)*cos(dStLon-dEvLon)));

	/*Calculate the distance in km*/
	*pDist = *pGcArc * 2.0 * pai * 6371.0/360.0;

	/*Calculate Azimuth which is from stEvent to Station in the site of earthquake*/
	*pAz = A2D(atan2(sin(dStLon-dEvLon), cos(dEvLat)*tan(dStLat)-sin(dEvLat)*cos(dStLon-dEvLon)));
	if(*pAz < 0.0) *pAz += 360.0;

	/*Calculate Azimuth which is from Station to stEvent in the site of station*/
	*pBaz = A2D(atan2(sin(dEvLon-dStLon), cos(dStLat)*tan(dEvLat)-sin(dStLat)*cos(dEvLon-dStLon)));
	if(*pBaz < 0.0) *pBaz += 360.0;

//	printf("gcarc=%f dist=%f az=%f baz=%f.\n",*pfGcArc,*pfDist,*pfAz,*pfBaz);
	return 1;
}


